//+------------------------------------------------------------------+
//|                                                     _PosiMon.mq4 |
//|                                         Copyright (c) 2009, fai. |
//|                                     http://www.himitukessya.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2009, fai"
#property link      "http://www.himitukessya.com/"
#property indicator_chart_window

extern bool EntryAlert = true;
extern bool ExitAlert  = true;
extern string About_MagicNumbers = "INPUT Magic Number with HANKAKU-SPACE separator..";
// }WbNio[w肵Ȃꍇ́AMagicNumbers󗓂ɂ邱ƁB
extern string MagicNumbers = "371443 3714431 3714432";
extern int CheckTimeInterval = 5;

int MagicNumbersArray[];
int CurrentPositionsArray[];
int PreviousPositionsArray[];
int CurrentPositionsNum  = 0;
int PreviousPositionsNum = 0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   MakeMagicNumberList();
}


int start()
  {
   static int lastCheckTime = 0;
   //CheckTimeInterval(5)bȏ1`FbN
   if(TimeCurrent()-lastCheckTime < CheckTimeInterval) return(0);
   lastCheckTime =TimeCurrent();
   
   GetCurrentPositions();
   int Opend  = 0;
   int Closed = 0;
   int i,j,exist;
////////////////////////////////////   
   if(EntryAlert){  
      for(i= 0;i<CurrentPositionsNum;i++){
         exist = 0;
         for(j = 0;j<PreviousPositionsNum;j++){
            if(CurrentPositionsArray[i] == PreviousPositionsArray[j]){
              exist = 1;
              break;
            }
         }
         if(exist == 0) Opend++;     
      }
   }//EntryAlert
////////////////////////////////////
   if(ExitAlert){  
      for(i= 0;i < PreviousPositionsNum;i++){
         exist = 0;
         for(j = 0;j < CurrentPositionsNum;j++){
            if(PreviousPositionsArray[i] == CurrentPositionsArray[j]){
              exist = 1;
              break;
            }
         }
         if(exist == 0) Closed++;     
      }
   }//ExitAlert   
////////////////////////////////////
   string msg = "OP["+CurrentPositionsNum+"] ";
   if(EntryAlert && Opend > 0){ msg = msg + "New Opend["+Opend+"] "; }  
   if(ExitAlert && Closed > 0){ msg = msg + "Closed["+Closed+"]"; }
   if((EntryAlert && Opend > 0) || (ExitAlert && Closed > 0)){
      Alert(msg);
      Print("-----------------"+msg);
      // [𑗂肽Ȃȉ̂
      //SendMail("PosiMon"+msg,msg);
      //Comment(msg);
   }
   //Comment(msg);
////////////////////////////////////
   PreviousPositionsNum = CurrentPositionsNum;
   ArrayResize(PreviousPositionsArray,CurrentPositionsNum);
   for(i= 0;i<CurrentPositionsNum;i++){
   PreviousPositionsArray[i] = CurrentPositionsArray[i];
   }   
   
   return(0);
  }
// the end.

//+------------------------------------------------------------------+
// ݕۗLĂ|WXgAbv
void GetCurrentPositions(){
   int orders = OrdersTotal();
   ArrayResize(CurrentPositionsArray,orders);
   for(int i= 0;i<orders;i++) CurrentPositionsArray[i]=0;

   CurrentPositionsNum = 0;//orders;//0;
   for(int cnt=orders-1;cnt>=0;cnt--){
      OrderSelect(cnt,SELECT_BY_POS);
      if(OrderSymbol() == Symbol()
      && CheckMagicNumber(OrderMagicNumber())
      && (OrderType() == OP_BUY || OrderType() == OP_SELL)
      ){
       CurrentPositionsArray[CurrentPositionsNum] = OrderTicket();
       CurrentPositionsNum++;
      }
   }//for
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
// }WbNio[̃Xg쐬B
int MakeMagicNumberList(){
   
   MagicNumbers = StringTrimLeft(MagicNumbers);
   MagicNumbers = StringTrimRight(MagicNumbers);

   int start = 0;
   int index;
   string MN;
   while(index !=-1){
      index = StringFind(MagicNumbers, " ", start);
      MN    = StringSubstr(MagicNumbers, start, index-start);
      Alert("PosiMon Target MN =["+MN+"]");
      start = index+1;
      if(MN !=""){
      ArrayResize(MagicNumbersArray,ArraySize(MagicNumbersArray)+1);
      MagicNumbersArray[ArraySize(MagicNumbersArray)-1] = StrToInteger(MN);
      }
   } 
}

//+------------------------------------------------------------------+
// }WbNio[vĂ邩H
bool CheckMagicNumber(int TargetMagicNumber){
//return(true);
   int count = ArraySize(MagicNumbersArray);
   if(count == 0) return(true);
   
   for(int i=0; i<count; i++)
   {
      if(MagicNumbersArray[i] == TargetMagicNumber) return(true);
   }
   return (false);
}

